#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>
#include <EEPROM.h>

float nowImpulse;
float impulses = 0;
float kwts = 0;
float impulses2 = 0;
float kwts2 = 0;

int msec=0;

WiFiClient client;

const char* host = "it.iu-dev.com";

int state;

void reboot() {
  wdt_disable();
  wdt_enable(WDTO_15MS);
  while (1) {}
}

String master, slot1_id, slot2_id, slot1_start, slot2_start, ssid, pass, verdict;
void setup() {
  EEPROM.begin(1024);
  pinMode(D1, INPUT);
  Serial.begin(115200);
   Serial.print("  Null (0/1): ");
    while (Serial.available() == 0) {  }
    verdict = Serial.readString();
    if(verdict == "1") {
  EEPROM.put(1, 811689527);
  EEPROM.commit();
    }
  EEPROM.get(1, state);
  Serial.println(state);
  delay(3000);
  if (state == 811689527) {
    Serial.println("==================== INFOTRANSFER JKH ====================");
    Serial.println("= MODEL INFOTRANSER JKH LITE | SERIAL NUMBER LITE/000001 =");
    Serial.println("==================== NEW DEVICE SETUP ====================");
    Serial.print("Enter Master ID: ");
    while (Serial.available() == 0) {  }
    master = Serial.readString();
    EEPROM.put(512, master);
    EEPROM.commit();
    Serial.println(master);
    Serial.println("Counters Data:");
    Serial.println(" Slot #1 Electric energy");
    Serial.print("  Enter Counter ID: ");
    while (Serial.available() == 0) {  }
    slot1_id = Serial.readString();
    EEPROM.put(100, slot1_id.toInt());
    Serial.println(slot1_id);
    Serial.print("  Enter Start data: ");
    while (Serial.available() == 0) {  }
    slot1_start = Serial.readString();
    EEPROM.put(16, slot1_start.toFloat());
    EEPROM.commit();
    EEPROM.put(8, (slot1_start.toFloat())*1600);
    EEPROM.commit();
    Serial.println(slot1_start);
    Serial.println(" Slot #2 Water");
    Serial.print("  Enter Counter ID: ");
    while (Serial.available() == 0) {  }
    slot2_id = Serial.readString();
    Serial.println(slot2_id);
    EEPROM.put(108, slot2_id.toInt());
    EEPROM.commit();
    Serial.print("  Enter Start data: ");
    while (Serial.available() == 0) {  }
    slot2_start = Serial.readString();
    Serial.println(slot2_start);
    EEPROM.put(32, slot2_start.toFloat());
    EEPROM.commit();
    Serial.println("Scanning WiFi Networks...");
    int n = WiFi.scanNetworks();
    Serial.println("scan done");
    if (n == 0) {
      Serial.println("no networks found");
    } else {
      Serial.print(n);
      Serial.println(" networks found");
      for (int i = 0; i < n; ++i) {
        // Print SSID and RSSI for each network found
        Serial.print(i + 1);
        Serial.print(": ");
        Serial.print(WiFi.SSID(i));
        Serial.print(" (");
        Serial.print(WiFi.RSSI(i));
        Serial.print(")");
        Serial.println((WiFi.encryptionType(i) == ENC_TYPE_NONE) ? " " : "*");
        delay(10);
      }
    }
    Serial.println("");
    Serial.print("Write SSID: ");
    while (Serial.available() == 0) {  }
    ssid = Serial.readString();
    Serial.println(ssid);
    EEPROM.put(600, ssid);
    Serial.print("Write PASS: ");
    while (Serial.available() == 0) {  }
    pass = Serial.readString();
    Serial.println(pass);
    EEPROM.put(620, pass);
    state = 1;
    EEPROM.put(1, state);
    EEPROM.commit();
  }  // Initialize the output variables as outputs

  // Connect to Wi-Fi network with SSID and password
  Serial.print("Connecting to ");
  EEPROM.get(600, ssid);
  EEPROM.get(620, pass);
  Serial.println(ssid);
  WiFi.begin(ssid, pass);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  if (client.connect(host, 80)) {
    Serial.println("Connected");
  }
  // String url = 
  //  
  // 
}

void send_data(String request){
  client.print(String("GET ")+request+" HTTP/1.1\r\nHost: "+host+"\r\n\r\n");
  client.println();
}

int state1 = 0;
int state2 = 0;
int spos = 0;
int counterid;
float pokazaniye;
    
void loop() {
    EEPROM.get(8, impulses);
    EEPROM.get(16, kwts);
    EEPROM.get(32, impulses2);
    EEPROM.get(24, kwts2);
    if (state1 == 1){
      if(digitalRead(D2)){
        impulses = impulses + 1;
        Serial.print("#1 Impulses: ");
        Serial.print(impulses);
        Serial.println();
        kwts = impulses / 1600;
        Serial.print("#1 kWt/h: ");
        Serial.print(kwts);
        Serial.println();
        EEPROM.put(8, impulses);
        EEPROM.put(16, kwts);
        EEPROM.commit();
        state1 = 0;
      }
    }

    if (state2 == 1){
      if(digitalRead(D1)){
        impulses2 = impulses2 + 1;
        Serial.print("#2 Impulses: ");
        Serial.print(impulses2);
        Serial.println();
        kwts2 = impulses2 / 100;
        Serial.print("#2 m3 : ");
        Serial.print(kwts2);
        Serial.println();
        EEPROM.put(32, impulses2);
        EEPROM.put(24, kwts2);
        EEPROM.commit();
        state2 = 0;
      }
    }
    
    if (!digitalRead(D2)) {
      state1 = 1;
    }
    
    if (!digitalRead(D1)) {
      state2 = 1;
    }
  delay(1);
  msec++;
  if(msec >= 60000){
    if(spos==0){
    EEPROM.get(108, counterid);
    EEPROM.get(24, pokazaniye);
    send_data(String("/api.php?counter=")+counterid+String("&data=")+String(pokazaniye));
    Serial.println(String("/api.php?counter=")+counterid+String("&data=")+String(pokazaniye));
    spos=1;
    }
    else if(spos==1){
    EEPROM.get(16, pokazaniye);
    EEPROM.get(100, counterid);
    send_data(String("/api.php?counter=")+counterid+String("&data=")+String(pokazaniye));
    Serial.println(String("/api.php?counter=")+counterid+String("&data=")+String(pokazaniye));
    spos=0;
    }
    msec = 0;
  }
}
